/***********************************************************
 formcheck 
gcc -o formchk formchk.c
vO̎`FbNs
formchk p02ex01.c 2J01
vO̕Ԃl
-1FɃt@CȂ
-2Fŗ^t@CȂ
-3F^uƃXy[X݂ĎsĂ
-4FmFłȂ
0FI
lFɖ肪@肪ꂽsԍi1琔Ăj
***********************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

//#define DEBUG
#define PRINT

deleteRTLF(char *txt)
{
	char *p=strchr(txt,'\n');
	char *q=strchr(txt,'\r');
	if (p) *p='\0';
	if (q) *q='\0';
}

void replaceKanji(char *txt)
{
	int iskanji=0;
	while(*txt) {
		if (iskanji==0 && (*txt&0x80)) {
			*txt='.';
			iskanji=1;
		} else if (iskanji) {
			*txt='.';
			iskanji=0;
		}
		txt++;
	}
}

void replaceDQ(char *txt)
{
	char *p;
	p=txt;
	while (p=strstr(txt,"\\\"")) {
		*p++='.';
		*p++='.';
	}
	p=txt;
	while (p=strstr(txt,"'{'")) {
		p++;
		*p++='.';
	}
	p=txt;
	while (p=strstr(txt,"'}'")) {
		p++;
		*p++='.';
	}
}

void removeStaticString(char *txt)
{
	char *p1,*p2;
	p1=txt;
	while (p1=strchr(p1,'\"')) {
		p2=strchr(p1+1,'\"');
		if (p2) {
			p2++;
			while (p1<p2) {
				*p1++='.';
			}
			p1=p2;
		} else {
			return;
		}
	}
}

void removeCComment(char *txt)
{
	char *p1,*p2;
	p1=txt;
	while (p1=strstr(p1,"/*")) {
		p2=strstr(p1+1,"*/");
		if (p2) {
			p2+=2;
			while (p1<p2) {
				*p1++=' ';
			}
			p1=p2;
		} else {
			return;
		}
	}
}

void removeCppComment(char *txt)
{
	char *p=strstr(txt,"//");
	if (p) *p='\0';
}

void removeSharpCommand(char *txt)
{
	char *p=txt;
	while (*p=='\t' || *p==' ') p++;
	if (*p=='#') *txt='\0';
}

void removeBlankLine(char *txt)
{
	char *p=txt;
	while (*p=='\t' || *p==' ') p++;
	if (!*p) *txt='\0';
}

//sɂ킽Rg̊Jn
int removeCComment1(char *txt)
{
	char *p=strstr(txt,"/*");
	if (p) {
		*p='\0';
		return 1; //
	} else {
		return 0; //Ȃ
	}
}

//sɂ킽Rg̏I[
int removeCComment2(char *txt)
{
	char *p=strstr(txt,"*/");
	if (p) {
		p+=2;
		while (*p) {
			*txt++=*p++;
		}
		*txt='\0';
		return 0; //
	} else {
		return 1; //Ȃ
	}
}

void removeRightSpace(char *txt)
{
	char *p=txt;
	while (*p) p++;
	p--;
	while (txt<=p && (*p=='\t' || *p==' ')) {
		*p='\0';
		p--;
	}
}

//s{}菜
void removeBracePair(char *txt)
{
	char *p1,*p2;
	int i;
	for (i=0;i<3;i++) {
		p1=txt;
		while (p1=strchr(p1,'{')) {
			p2=strchr(p1+1,'}');
			if (p2) {
				*p1='.';
				*p2='.';
				p1=p2;
			} else {
				break;
			}
		}
	}
}

//{}ɂCfg[̕ωԂ
int checkBraces(char *txt)
{
	char *p;
	int level=0;
	p=txt;
	while (*p) {
		if (*p=='{') level++;
		else if (*p=='}') level--;
		p++;
	}
	return level;
}

//@} else {ɂÕ`FbN
//@} else if (xxxxxxxxx) {ɂÕ`FbN
// ߂l@1:@0:Ȃ
int checkDoubleBraces(char *txt)
{
	char *p;
	int found=0;
	p=txt;
	while (*p) {
		if (*p=='}') found=1;
		p++;
		if (found) break;
	}
	while (*p) {
		if (*p=='{') found=2;
		p++;
		if (found==2) break;
	}
	if (found==2) return 1;
	else return 0;
}

//()ɂCfg[̕ωԂ
int checkParentheses(char *txt)
{
	char *p;
	int level=0;
	p=txt;
	while (*p) {
		if (*p=='(') level++;
		else if (*p==')') level--;
		p++;
	}
	return level;
}

//s̃Cfg̕܂̓Cfg̃Xy[X
//1`:indentspacegp@100:indenttabgp
int countSpace(char *txt)
{
	int count=0;
	if (*txt=='\t') {
		count = 100;
	} else {
		while (*txt==' ') {
			count++;
			txt++;
		}
	}
	return count;
}

//^ꂽs̃Cfg̐[𐔂ĕԂ֐
//CfgXy[XōsĂCspace̒萔{łȂ΃G[
//G[̓Cfg̐[-1{Ԃ
int countIndent(int space, char *txt)
{
	int count=0;
	if (space==100) {//CfgTAB
		while (*txt++=='\t') count++;
		txt--;
		if (*txt==' ') count=-count;
	} else {
		while (*txt++==' ') count++;
		if (count%space!=0) count=-count/space;
		else count/=space;
	}
	return count;
}
/* ̂悤ȗOKƂł邽߂ɔzC̐ԂƂɂ@20130531
int xxxx[]={
	1234,2345,3456,4567,
	 123,2345,3456,4567
};
*/

//str̍̋󔒂菜trimd
void trimLeft(char *str, char *trimd)
{
	while(*str==' ' || *str=='\t') str++;
	while(*str) *trimd++=*str++;
	*trimd='\0';
}

//txt̐擪L[hwordŎn܂Ă邩ǂ`FbN
//1: n܂Ă@0: ł͂Ȃ
//[hƂworďɉpqĂȂ
int checkStratWord(char *txt, char *word)
{
	char ch;
	char tmp[1024];
	trimLeft(txt,tmp);
	if (strstr(tmp,word)!=tmp) return 0;
	ch=tmp[strlen(word)];
	if (isalnum(ch)) return 0;
	return 1;
}

//擪L܂-Ȃ1
//łȂ0
int checkNumeric(char *str)
{
	char tmp[1024];
	trimLeft(str,tmp);
	if (isdigit(tmp[0]) || tmp[0]=='-') return 1;
	return 0;
}

#define BUFFERSIZE 2048

//ckfnamewkfnameɏ
//Ԃl@0F@1Fs
int removeUnwanted(char *ckfname, char *wkfname)
{
	FILE *ck, *wk;
	int CComment=0;
	char buff[BUFFERSIZE];
	ck=fopen(ckfname,"r");
	if (ck==NULL) return 1;
	wk=fopen(wkfname,"w");
	if (wk==NULL) return 1;
	while (fgets(buff,BUFFERSIZE,ck)!=NULL) {
		deleteRTLF(buff);         //s\n
		replaceKanji(buff);       //SJISR[hi2oCgju..vɕύX
		replaceDQ(buff);          //u\"vu..vɕύX
		removeStaticString(buff); //1śu"vň͂܂ꂽÓȈ
		removeCComment(buff);     //1s/*EE*/`̃Rg폜
		removeCppComment(buff);   //u//ṽRg폜
		removeSharpCommand(buff); // #Ŏn܂s̍폜
		if (CComment==0) { //sɂ킽Rg͒łȂ
			CComment=removeCComment1(buff);
		} else { //sɂ킽Rg͒ł
			CComment=removeCComment2(buff);
			if (CComment) buff[0]='\0';
			else CComment=removeCComment1(buff);
		}
		removeRightSpace(buff); //E[ɂXy[X菜
		removeBracePair(buff); //s{}菜
		removeBlankLine(buff); //Xy[XłłĂs󔒍sɂ
		//printf("%s\n",buff);
		fprintf(wk,"%s\n",buff);
	}
	//n
	fclose(ck);
	fclose(wk);
	return 0;
}

//Cfgispacej𐄒肷
//߂l@space
//        100 TAB
//        -1 spaceEtab
//        -2 t@CJȂ
int guessIndentation(char *wkfname)
{
	FILE *wk;
	char buff[BUFFERSIZE];
	int count[110];
	int i,res;
	wk=fopen(wkfname,"r");
	if (wk==NULL) return -2;
	for (i=0; i<110; i++) count[i]=0;
	while (fgets(buff,BUFFERSIZE,wk)!=NULL) {
		res=countSpace(buff);
		if (0<=res && res<=100) count[res]++;
	}
	fclose(wk);
	if (count[100]!=0) {
		i=1;
		while (count[i]==0 && i!=99) i++;
		if (i==99) return 100;
		return -1;
	}
	i=1;
	while (count[i]==0 && i!=99) i++;
	if (i==99) return 0;
	i=1;
	while (count[i]<=count[i+1] && i!=98) i++;
	if (i==98) return 0;
	return i;
}


//t@C݂̑m߂
//fnameFΏۃt@C
int file_exists(char *fname)
{
	FILE *fp;
	fp=fopen(fname,"r");
	if (fp==NULL) return 0;
	fclose(fp);
	return 1;
}

//`FbN܂
//Ԃl@ȂF0@肠̂Ƃ͍sԍԂ
int analysisIndentation(char *wkfname, int indentwidth)
{
	FILE *wk;
	char buff[BUFFERSIZE];
	int linenum=1;
	int t1,t2,t3;
	int desiredindent=0;
	int exceptionParentheses=0; //ĩlXg̐
	int exceptionBraces=0; //u} else { ̗Ov̍sł
	int exceptionSwitch=0; // switch̃lXg[
	int caseIndentlevel=-1; //casẽCfgx@Ō܂
	                     //switchcaseȂ0Ccase1CfgĂ1
	int exceptionDoubleBraces; //} else { ̗O 0/1
	int exceptionSwitchrequest; //switch̗Öɓ
	int indentSwitch[20]; //switch̃Cfg
	wk=fopen(wkfname,"r");
	if (wk==NULL) return -2;
	while (fgets(buff,BUFFERSIZE,wk)!=NULL) {
		deleteRTLF(buff);         //s\n
		if (buff[0]==0) {
			linenum++;
			continue;
		}
		t1=checkBraces(buff); //{}ɂCfg̕ω@̍sɉe
		t2=checkParentheses(buff); //()ɂCfg̕ω@̍sŏ
		t3=countIndent(indentwidth,buff); //ڍs̃Cfg[
		
		//fobOC\
		//printf("t1 t2 t3 des= %2d %2d %2d %4d %s\n", t1,t2,t3,desiredindent,buff);

		if (t3<0 && exceptionParentheses!=0) t3=-t3;
		exceptionDoubleBraces=checkDoubleBraces(buff); //} else { ̗O 0/1

		if (t1<0) desiredindent+=t1;
		if (checkNumeric(buff)) {
			if (desiredindent<=t3) {
				t3=desiredindent;
			} else if (desiredindent<=-t3) {
				t3=desiredindent;
			} else {
				fclose(wk);
				return  linenum; //G[@G[̍sԍԂ
			}
		}

		exceptionSwitchrequest=0;
		if (checkStratWord(buff,"switch")) {
			exceptionSwitchrequest=1;
			indentSwitch[exceptionSwitch+1]=t3;
		}
		if (exceptionSwitch!=0) {
			if (checkStratWord(buff,"}")) {
				if (indentSwitch[exceptionSwitch]==t3) {
					exceptionSwitch--;
				}
			}
		}
		if (exceptionSwitch==0) { //ʏ̃`FbN
			if (t3<0) {
				fclose(wk);
				return linenum; //G[@G[̍sԍԂ
			}
			if (exceptionParentheses==0 
				&& t3!=desiredindent-exceptionDoubleBraces) {
				fclose(wk);
				return linenum; //G[@G[̍sԍԂ
			}
		} else { //switchubÑ`FbN
			if (checkStratWord(buff,"case") || checkStratWord(buff,"default")) {
				if (t3<0) t3=-t3;
				if (caseIndentlevel==-1) { //ŏcase
					//print "desiredindent,t3=".desiredindent." ".t3."\n";
					if (t3+1==desiredindent) {
						caseIndentlevel=0;
					} else if (t3==desiredindent) {
						caseIndentlevel=1;
					} else {
						fclose(wk);
						return linenum; //G[@G[̍sԍԂ
					}
				} else {
					//print "desiredindent,t3=".desiredindent." ".t3."\n";
					if (t3!=desiredindent-1+caseIndentlevel*exceptionSwitch) {
						fclose(wk);
						return linenum; //G[@G[̍sԍԂ
					}
				}
			} else {
				if (t3!=desiredindent+caseIndentlevel*exceptionSwitch-exceptionDoubleBraces) {
					fclose(wk);
					return linenum; //G[@G[̍sԍԂ
				}
			}
		}
		if (t3<0 && exceptionParentheses==0) {
			fclose(wk);
			return linenum; //G[@G[̍sԍԂ
		}

		//̍ŝ߂̏
		exceptionParentheses+=t2;
		if (0<t1) desiredindent+=t1;
		exceptionSwitch+=exceptionSwitchrequest;
		linenum++;
	}
	fclose(wk);
	return 0;
}

char *openningmessage={
	" ***********************************************************\n"
	" *\n"
	" *   formchk.exe    Indentation Checker for Program Codes\n"
	" *                 Coskx Lab 20180305  since 2003\n"
	" *\n"
	" *   usage:   >formchk xxxxxxx.c\n"
	" *            >formchk yyyyyyy.java\n"
	" *\n"
	" ***********************************************************\n\n"
};


#define FILENAME_MAXLENGTH    260

int main(int argc, char *argv[])
{
	char filenametocheck[FILENAME_MAXLENGTH];
	char workfname[FILENAME_MAXLENGTH];
	int result;
	int indentwidth; //Cfgl@space̐C100ȂTAB
	puts(openningmessage);
	if (argc<2) {
		#ifdef PRINT
		printf("error .. no filename\n");
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-1);
	}
	strcpy(filenametocheck,argv[1]);
	printf(" *  indentation checking [%s]\n\n",filenametocheck);
	if (!file_exists(filenametocheck)) {
		#ifdef PRINT
		printf("error .. can't open %s\n",filenametocheck);
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-2);
	}
	strcpy(workfname,filenametocheck);
	strcat(workfname,".txt");
	result=removeUnwanted(filenametocheck,workfname); //filenametocheckworkfnameɏ
	if (result!=0) {
		#ifdef PRINT
		printf("error .. can't open %s or %s\n",filenametocheck, workfname);
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-2);
	}
	indentwidth=guessIndentation(workfname);
	if (indentwidth==-2) {
		#ifdef PRINT
		printf("error .. can't open %s\n", workfname);
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-2);
	}
	if (indentwidth==0) {
		remove(workfname);
		#ifdef PRINT
		printf("mFł܂\n");
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-3);
	}
	if (indentwidth==-1) {
		remove(workfname);
		#ifdef PRINT
		printf("TabSpace݂ĂCsK؂ł\n");
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(-4);
	}
	result=analysisIndentation(workfname,indentwidth);
	if (result!=0) {
		remove(workfname);
		#ifdef PRINT
		printf("%dsڂɎG[܂\n",result);
		printf("EnterL[ŏI܂");
		getchar();
		#endif
		exit(result);
	}
	remove(workfname);
	#ifdef PRINT
	printf("ɖ͂܂\n");
	printf("EnterL[ŏI܂");
	getchar();
	#endif
	return 0;
}
/*
memo
() parentheses, round brackets - 
[] box brackets - 
{} braces, curly brackets 

*/
